﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Net;
using System.Net.Security;
using Foundation;
using Newtonsoft.Json;
using Syncfusion.SfAutoComplete.iOS;
using UIKit;

namespace AutoComplete_iOS
{
    public partial class ViewController : UIViewController
    {
        protected ViewController(IntPtr handle) : base(handle)
        {
            // Note: this .ctor should not contain any initialization logic.
        }

        SfAutoComplete autoComplete;
        UILabel value;
        public override void ViewDidLoad()
        {
            base.ViewDidLoad();

            //autoComplete
            autoComplete = new SfAutoComplete();
            autoComplete.Frame = new CoreGraphics.CGRect(10, 80, 300, 40);
            autoComplete.Watermark =(NSString) "Enter Text 600001";
            //Add the items
            autoComplete.TextChanged+= AutoComplete_TextChanged;
            autoComplete.SelectionChanged+= AutoComplete_SelectionChanged;

            UILabel name = new UILabel(new CoreGraphics.CGRect(10, 120, 100, 40));
            name.Text =(NSString) "Office Name";
             value = new UILabel(new CoreGraphics.CGRect(120, 120, 180, 40));
            
            this.View.Add(name);
            this.View.Add(value);
            this.View.Add(autoComplete);

        }

        void AutoComplete_SelectionChanged(object sender, SelectionEventArgs e)
        {
            value.Text = (e.Value as Data).OfficeName;
        }


        void AutoComplete_TextChanged(object sender, TextEventArgs e)
        {
            if(e.Value.Length==6)
                AddDataSource(e.Value);
        }

        ObservableCollection<Data> areaCollection;
        void AddDataSource(string value)
        {
            string url = "https://pincode.saratchandra.in/api/pincode/"+value;
            HttpWebRequest getRequest = (HttpWebRequest)WebRequest.Create(url);
            getRequest.Method = "GET";
            getRequest.Credentials = new NetworkCredential("UN", "PW");
            ServicePointManager.ServerCertificateValidationCallback = new
               RemoteCertificateValidationCallback
               (
                  delegate { return true; }
               );

            var getResponse = (HttpWebResponse)getRequest.GetResponse();
            Stream newStream = getResponse.GetResponseStream();
            StreamReader sr = new StreamReader(newStream);
            var result = sr.ReadToEnd();
            areaCollection = new ObservableCollection<Data>();
            var splashInfo = JsonConvert.DeserializeObject<FullData>(result);
            for (int i = 0; i < splashInfo.data.Length; i++)
                areaCollection.Add(splashInfo.data[i]);

            autoComplete.DataSource = areaCollection;
            autoComplete.DisplayMemberPath = (NSString)"PinCode";
        }

        public class Post
        {
            public int userId { get; set; }
            public int id { get; set; }
            public string title { get; set; }
            public string body { get; set; }
        }

        public class PostDetails
        {
            public String Message { get; set; }
            public int id { get; set; }
            public string title { get; set; }
            public string body { get; set; }
        }
        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
            // Release any cached data, images, etc that aren't in use.
        }
        /// <summary>
        /// Contains filterred PinCode details from service
        /// </summary>
        public class FullData
        {
            #region Members

            public String status;
            public Data[] data;

            #endregion

            #region Constructor 
            FullData()
            {

            }

            #endregion
        }
        /// <summary>
        /// This Model is used to store the data fetch from RestService in FullData
        /// </summary>
        public class Data
        {
            #region properties

            public String pincode;
            public String office_name;
            public String delivery_status;
            public String division_name;
            public String region_name;
            public String circle_name;
            public String district;
            public String state_name;
            public String taluk;

            public string PinCode
            {
                set
                {
                    pincode = value;
                }
                get
                {
                    return pincode;
                }
            }

            public string OfficeName
            {
                set
                {
                    office_name = value;
                }
                get
                {
                    return office_name;
                }
            }

            public string DeliveryStatus
            {
                set
                {
                    delivery_status = value;
                }
                get
                {
                    return delivery_status;
                }
            }

            public string Division
            {
                set
                {
                    division_name = value;
                }
                get
                {
                    return division_name;
                }
            }

            public string Region
            {
                set
                {
                    region_name = value;
                }
                get
                {
                    return region_name;
                }
            }

            public string Circle
            {
                set
                {
                    circle_name = value;
                }
                get
                {
                    return circle_name;
                }
            }

            public string District
            {
                set
                {
                    district = value;
                }
                get
                {
                    return district;
                }
            }

            public string State
            {
                set
                {
                    state_name = value;
                }
                get
                {
                    return state_name;
                }
            }

            public string Taluk
            {
                set
                {
                    taluk = value;
                }
                get
                {
                    return taluk;
                }
            }

            #endregion
        }

        //public class FullData
        //{
        //    #region Members

        //    public String Message;
        //    public String Status;
        //    public PostOffice[] PostOffice;

        //    #endregion

        //    #region Constructor 
        //    FullData()
        //    {

        //    }

        //    #endregion
        //}
        ///// <summary>
        ///// This Model is used to store the data fetch from RestService in FullData
        ///// </summary>
        //public class PostOffice
        //{
        //    #region properties

        //    public String Name;
        //    public String Description;
        //    public String BranchType;
        //    public String DeliveryStatus;
        //    public String Taluk;
        //    public String Circle;
        //    public String District;
        //    public String Division;
        //    public String Region;
        //    public String State;
        //    public String Country;
        //    public string Country
        //    {
        //        set
        //        {
        //            branchType = value;
        //        }
        //        get
        //        {
        //            return branchType;
        //        }
        //    }
        //    public string Country
        //    {
        //        set
        //        {
        //            country = value;
        //        }
        //        get
        //        {
        //            return country;
        //        }
        //    }


        //    public string State
        //    {
        //        set
        //        {
        //            state = value;
        //        }
        //        get
        //        {
        //            return state;
        //        }
        //    }

        //    public string Region
        //    {
        //        set
        //        {
        //            region = value;
        //        }
        //        get
        //        {
        //            return region;
        //        }
        //    }

        //    public string Description
        //    {
        //        set
        //        {
        //            description = value;
        //        }
        //        get
        //        {
        //            return description;
        //        }
        //    }


        //    public string DeliveryStatus
        //    {
        //        set
        //        {
        //            deliveryStatus = value;
        //        }
        //        get
        //        {
        //            return deliveryStatus;
        //        }
        //    }

        //    public string Taluk
        //    {
        //        set
        //        {
        //            taluk = value;
        //        }
        //        get
        //        {
        //            return taluk;
        //        }
        //    }

        //    public string Circle
        //    {
        //        set
        //        {
        //            circle = value;
        //        }
        //        get
        //        {
        //            return circle;
        //        }
        //    }
        //    public string District
        //    {
        //        set
        //        {
        //            district = value;
        //        }
        //        get
        //        {
        //            return district;
        //        }
        //    }


        //    public string Division
        //    {
        //        set
        //        {
        //            division = value;
        //        }
        //        get
        //        {
        //            return division;
        //        }
        //    }
        //    #endregion
        //}
    }
}
